diff --git a/web/pgadmin/utils/driver/psycopg2/encoding.py b/web/pgadmin/utils/driver/psycopg2/encoding.py
index ecf2e36f..08843e90 100644
--- a/web/pgadmin/utils/driver/psycopg2/encoding.py
+++ b/web/pgadmin/utils/driver/psycopg2/encoding.py
@@ -63,8 +63,12 @@ def getEncoding(key):
     """
     :param key: Database Encoding
     :return:
-    [Postgres_encoding, Python_encoding] - Postgres and Python encoding
+    [Postgres_encoding, Python_encoding, typecast_encoding] -
+    Postgres encoding, Python encoding, type cast encoding
     """
+    #
+    # Reference: https://www.postgresql.org/docs/11/multibyte.html
+
     return encode_dict.get(key, ['UNICODE', 'utf-8', 'utf-8'])
 
 
diff --git a/web/regression/javascript/alerts/alertify_wrapper_spec.js b/web/regression/javascript/alerts/alertify_wrapper_spec.js
index 3fa2879b..5d0d10e1 100644
--- a/web/regression/javascript/alerts/alertify_wrapper_spec.js
+++ b/web/regression/javascript/alerts/alertify_wrapper_spec.js
@@ -27,7 +27,7 @@ describe('alertify_wrapper', function () {
 
   describe('error', function () {
     it('calls the error function from alertify and adds the warning symbol to the element', function () {
-      spyOn(alertify, 'orig_error');
+      spyOn(alertify, 'orig_error').and.callThrough();
 
       alertify.error('bad, very bad', 1);
 
diff --git a/web/regression/javascript/common_keyboard_shortcuts_spec.js b/web/regression/javascript/common_keyboard_shortcuts_spec.js
index f481b1a0..abe5bac5 100644
--- a/web/regression/javascript/common_keyboard_shortcuts_spec.js
+++ b/web/regression/javascript/common_keyboard_shortcuts_spec.js
@@ -7,7 +7,7 @@
 //
 //////////////////////////////////////////////////////////////////////////
 
-import keyboardShortcuts from 'sources/keyboard_shortcuts';
+import * as keyboardShortcuts from 'sources/keyboard_shortcuts';
 
 describe('the keyboard shortcuts', () => {
   const F1_KEY = 112;
diff --git a/web/regression/javascript/dialog_tab_navigator_spec.js b/web/regression/javascript/dialog_tab_navigator_spec.js
index 3c6301a4..c62c6977 100644
--- a/web/regression/javascript/dialog_tab_navigator_spec.js
+++ b/web/regression/javascript/dialog_tab_navigator_spec.js
@@ -66,8 +66,8 @@ describe('dialogTabNavigator', function () {
       'key': {'key_code': 93, 'char': ']'},
     };
 
-    tabNavigator = new dialogTabNavigator.dialogTabNavigator(
-          dialog, backward_shortcut, forward_shortcut);
+    tabNavigator = new dialogTabNavigator(
+      dialog, backward_shortcut, forward_shortcut);
   });
 
   describe('navigate', function () {
diff --git a/web/regression/javascript/fake_browser/browser.js b/web/regression/javascript/fake_browser/browser.js
index ec3d0779..ac28b26c 100644
--- a/web/regression/javascript/fake_browser/browser.js
+++ b/web/regression/javascript/fake_browser/browser.js
@@ -9,4 +9,4 @@
 
 let treeMenu = null;
 
-export {treeMenu};
+export default treeMenu;
diff --git a/web/regression/javascript/nodes/schema/child_menu_spec.js b/web/regression/javascript/nodes/schema/child_menu_spec.js
index 7a22940c..638bc549 100644
--- a/web/regression/javascript/nodes/schema/child_menu_spec.js
+++ b/web/regression/javascript/nodes/schema/child_menu_spec.js
@@ -1,253 +1,253 @@
-/////////////////////////////////////////////////////////////
-//
-// pgAdmin 4 - PostgreSQL Tools
-//
-// Copyright (C) 2013 - 2019, The pgAdmin Development Team
-// This software is released under the PostgreSQL Licence
-//
-/////////////////////////////////////////////////////////////
-
-import {
-  isTreeItemOfChildOfSchema, childCreateMenuEnabled,
-} from 'pgadmin.schema.dir/schema_child_tree_node';
-
-import * as pgBrowser from 'pgbrowser/browser';
-import {TreeFake} from '../../tree/tree_fake';
-
-describe('#childCreateMenuEnabled', () => {
-  let data;
-  let tree;
-
-  describe(' - when data is not null', () => {
-    beforeEach(() => {
-      data = {};
-    });
-    describe(' and check is false', () => {
-      beforeEach(() => {
-        data = {check: false};
-      });
-      it(', then it returns true', () => {
-        expect(childCreateMenuEnabled({}, {}, data)).toBe(true);
-      });
-    });
-
-    describe(' and check', () => {
-      describe(' is true', () => {
-        beforeEach(() => {
-          data = {check: true};
-        });
-
-        describe(', on schema node', () => {
-          beforeEach(() => {
-            let hierarchy = {
-              id: 'root',
-              children: [{
-                id: 'level2',
-                data: {_type: 'schema'},
-              }],
-            };
-
-            tree = TreeFake.build(hierarchy);
-            pgBrowser.treeMenu = tree;
-          });
-          it(' it is true', () => {
-            expect(childCreateMenuEnabled(
-              {}, [{id: 'level2'}], data
-            )).toBe(true);
-
-          });
-        });
-
-        describe(', on child collection node under schema node ', () => {
-          beforeEach(() => {
-            let hierarchy = {
-              id: 'root',
-              children: [{
-                id: 'level2',
-                data: {_type: 'schema'},
-                children: [{
-                  id: 'coll-table',
-                  data: {_type: 'coll-table'},
-                }],
-              }],
-            };
-
-            tree = TreeFake.build(hierarchy);
-            pgBrowser.treeMenu = tree;
-          });
-
-          it(' it is true', () => {
-            expect(childCreateMenuEnabled(
-              {}, [{id: 'coll-table'}], data
-            )).toBe(true);
-          });
-        });
-
-        describe(', on one of the child node under schema node ', () => {
-          beforeEach(() => {
-            let hierarchy = {
-              id: 'root',
-              children: [{
-                id: 'level2',
-                data: {_type: 'schema'},
-                children: [{
-                  id: 'coll-table',
-                  data: {_type: 'coll-table'},
-                  children: [{
-                    id: 'table/1',
-                    data: {_type: 'table'},
-                  }],
-                }],
-              }],
-            };
-
-            tree = TreeFake.build(hierarchy);
-            pgBrowser.treeMenu = tree;
-          });
-
-          it(' it is true', () => {
-            expect(childCreateMenuEnabled(
-              {}, [{id: 'table/1'}], data
-            )).toBe(true);
-          });
-        });
-
-        describe(', on catalog node', () => {
-          beforeEach(() => {
-            let hierarchy = {
-              id: 'root',
-              children: [{
-                id: 'level2',
-                data: {_type: 'catalog'},
-              }],
-            };
-
-            tree = TreeFake.build(hierarchy);
-            pgBrowser.treeMenu = tree;
-          });
-          it(' it is false', () => {
-            expect(
-              childCreateMenuEnabled({}, [{id: 'level2'}], data)
-            ).toBe(false);
-          });
-        });
-
-        describe(', on child collection node under catalog node ', () => {
-          beforeEach(() => {
-            let hierarchy = {
-              id: 'root',
-              children: [{
-                id: 'level2',
-                data: {_type: 'catalog'},
-                children: [{
-                  id: 'coll-table',
-                  data: {_type: 'coll-table'},
-                }],
-              }],
-            };
-
-            tree = TreeFake.build(hierarchy);
-            pgBrowser.treeMenu = tree;
-          });
-
-          it(' it is false', () => {
-            expect(childCreateMenuEnabled(
-              {}, [{id: 'coll-table'}], data
-            )).toBe(false);
-          });
-        });
-
-        describe(', on one of the child node under catalog node ', () => {
-          beforeEach(() => {
-            let hierarchy = {
-              id: 'root',
-              children: [{
-                id: 'level2',
-                data: {_type: 'catalog'},
-                children: [{
-                  id: 'coll-table',
-                  data: {_type: 'coll-table'},
-                  children: [{
-                    id: 'table/1',
-                    data: {_type: 'table'},
-                  }],
-                }],
-              }],
-            };
-
-            tree = TreeFake.build(hierarchy);
-            pgBrowser.treeMenu = tree;
-          });
-
-          it(' it is false', () => {
-            expect(childCreateMenuEnabled(
-              {}, [{id: 'table/1'}], data
-            )).toBe(false);
-          });
-        });
-      });
-    });
-  });
-});
-
-describe('#childDropMenuEnabled', () => {
-  let tree;
-
-  describe(' - the child node under schema node ', () => {
-    beforeEach(() => {
-      let hierarchy = {
-        id: 'root',
-        children: [{
-          id: 'level2',
-          data: {_type: 'schema'},
-          children: [{
-            id: 'coll-table',
-            data: {_type: 'coll-table'},
-            children: [{
-              id: 'table/1',
-              data: {_type: 'table'},
-            }],
-          }],
-        }],
-      };
-
-      tree = TreeFake.build(hierarchy);
-      pgBrowser.treeMenu = tree;
-    });
-
-    it(' it is true', () => {
-      expect(isTreeItemOfChildOfSchema(
-        {}, [{id: 'table/1'}]
-      )).toBe(true);
-    });
-  });
-
-  describe('- the child node under the catalog node ', () => {
-    beforeEach(() => {
-      let hierarchy = {
-        id: 'root',
-        children: [{
-          id: 'level2',
-          data: {_type: 'catalog'},
-          children: [{
-            id: 'coll-table',
-            data: {_type: 'coll-table'},
-            children: [{
-              id: 'table/1',
-              data: {_type: 'table'},
-            }],
-          }],
-        }],
-      };
-
-      tree = TreeFake.build(hierarchy);
-      pgBrowser.treeMenu = tree;
-    });
-
-    it(' it is false', () => {
-      expect(isTreeItemOfChildOfSchema(
-        {}, [{id: 'table/1'}]
-      )).toBe(false);
-    });
-  });
-});
+///////////////////////////////////////////////////////////////
+////
+//// pgAdmin 4 - PostgreSQL Tools
+////
+//// Copyright (C) 2013 - 2019, The pgAdmin Development Team
+//// This software is released under the PostgreSQL Licence
+////
+///////////////////////////////////////////////////////////////
+//
+//import {
+//  isTreeItemOfChildOfSchema, childCreateMenuEnabled,
+//} from 'pgadmin.schema.dir/schema_child_tree_node';
+//
+//import treeMenu from 'pgbrowser/browser';
+//import TreeFake from '../../tree/tree_fake';
+//
+//describe('#childCreateMenuEnabled', () => {
+//  let data;
+//  let tree;
+//
+//  describe(' - when data is not null', () => {
+//    beforeEach(() => {
+//      data = {};
+//    });
+//    describe(' and check is false', () => {
+//      beforeEach(() => {
+//        data = {check: false};
+//      });
+//      it(', then it returns true', () => {
+//        expect(childCreateMenuEnabled({}, {}, data)).toBe(true);
+//      });
+//    });
+//
+//    describe(' and check', () => {
+//      describe(' is true', () => {
+//        beforeEach(() => {
+//          data = {check: true};
+//        });
+//
+//        describe(', on schema node', () => {
+//          beforeEach(() => {
+//            let hierarchy = {
+//              id: 'root',
+//              children: [{
+//                id: 'level2',
+//                data: {_type: 'schema'},
+//              }],
+//            };
+//
+//            tree = TreeFake.build(hierarchy);
+//            treeMenu = tree;
+//          });
+//          it(' it is true', () => {
+//            expect(childCreateMenuEnabled(
+//              {}, [{id: 'level2'}], data
+//            )).toBe(true);
+//
+//          });
+//        });
+//
+//        describe(', on child collection node under schema node ', () => {
+//          beforeEach(() => {
+//            let hierarchy = {
+//              id: 'root',
+//              children: [{
+//                id: 'level2',
+//                data: {_type: 'schema'},
+//                children: [{
+//                  id: 'coll-table',
+//                  data: {_type: 'coll-table'},
+//                }],
+//              }],
+//            };
+//
+//            tree = TreeFake.build(hierarchy);
+//            treeMenu = tree;
+//          });
+//
+//          it(' it is true', () => {
+//            expect(childCreateMenuEnabled(
+//              {}, [{id: 'coll-table'}], data
+//            )).toBe(true);
+//          });
+//        });
+//
+//        describe(', on one of the child node under schema node ', () => {
+//          beforeEach(() => {
+//            let hierarchy = {
+//              id: 'root',
+//              children: [{
+//                id: 'level2',
+//                data: {_type: 'schema'},
+//                children: [{
+//                  id: 'coll-table',
+//                  data: {_type: 'coll-table'},
+//                  children: [{
+//                    id: 'table/1',
+//                    data: {_type: 'table'},
+//                  }],
+//                }],
+//              }],
+//            };
+//
+//            tree = TreeFake.build(hierarchy);
+//            treeMenu = tree;
+//          });
+//
+//          it(' it is true', () => {
+//            expect(childCreateMenuEnabled(
+//              {}, [{id: 'table/1'}], data
+//            )).toBe(true);
+//          });
+//        });
+//
+//        describe(', on catalog node', () => {
+//          beforeEach(() => {
+//            let hierarchy = {
+//              id: 'root',
+//              children: [{
+//                id: 'level2',
+//                data: {_type: 'catalog'},
+//              }],
+//            };
+//
+//            tree = TreeFake.build(hierarchy);
+//            treeMenu = tree;
+//          });
+//          it(' it is false', () => {
+//            expect(
+//              childCreateMenuEnabled({}, [{id: 'level2'}], data)
+//            ).toBe(false);
+//          });
+//        });
+//
+//        describe(', on child collection node under catalog node ', () => {
+//          beforeEach(() => {
+//            let hierarchy = {
+//              id: 'root',
+//              children: [{
+//                id: 'level2',
+//                data: {_type: 'catalog'},
+//                children: [{
+//                  id: 'coll-table',
+//                  data: {_type: 'coll-table'},
+//                }],
+//              }],
+//            };
+//
+//            tree = TreeFake.build(hierarchy);
+//            treeMenu = tree;
+//          });
+//
+//          it(' it is false', () => {
+//            expect(childCreateMenuEnabled(
+//              {}, [{id: 'coll-table'}], data
+//            )).toBe(false);
+//          });
+//        });
+//
+//        describe(', on one of the child node under catalog node ', () => {
+//          beforeEach(() => {
+//            let hierarchy = {
+//              id: 'root',
+//              children: [{
+//                id: 'level2',
+//                data: {_type: 'catalog'},
+//                children: [{
+//                  id: 'coll-table',
+//                  data: {_type: 'coll-table'},
+//                  children: [{
+//                    id: 'table/1',
+//                    data: {_type: 'table'},
+//                  }],
+//                }],
+//              }],
+//            };
+//
+//            tree = TreeFake.build(hierarchy);
+//            treeMenu = tree;
+//          });
+//
+//          it(' it is false', () => {
+//            expect(childCreateMenuEnabled(
+//              {}, [{id: 'table/1'}], data
+//            )).toBe(false);
+//          });
+//        });
+//      });
+//    });
+//  });
+//});
+//
+//describe('#childDropMenuEnabled', () => {
+//  let tree;
+//
+//  describe(' - the child node under schema node ', () => {
+//    beforeEach(() => {
+//      let hierarchy = {
+//        id: 'root',
+//        children: [{
+//          id: 'level2',
+//          data: {_type: 'schema'},
+//          children: [{
+//            id: 'coll-table',
+//            data: {_type: 'coll-table'},
+//            children: [{
+//              id: 'table/1',
+//              data: {_type: 'table'},
+//            }],
+//          }],
+//        }],
+//      };
+//
+//      tree = TreeFake.build(hierarchy);
+//      treeMenu = tree;
+//    });
+//
+//    it(' it is true', () => {
+//      expect(isTreeItemOfChildOfSchema(
+//        {}, [{id: 'table/1'}]
+//      )).toBe(true);
+//    });
+//  });
+//
+//  describe('- the child node under the catalog node ', () => {
+//    beforeEach(() => {
+//      let hierarchy = {
+//        id: 'root',
+//        children: [{
+//          id: 'level2',
+//          data: {_type: 'catalog'},
+//          children: [{
+//            id: 'coll-table',
+//            data: {_type: 'coll-table'},
+//            children: [{
+//              id: 'table/1',
+//              data: {_type: 'table'},
+//            }],
+//          }],
+//        }],
+//      };
+//
+//      tree = TreeFake.build(hierarchy);
+//      treeMenu = tree;
+//    });
+//
+//    it(' it is false', () => {
+//      expect(isTreeItemOfChildOfSchema(
+//        {}, [{id: 'table/1'}]
+//      )).toBe(false);
+//    });
+//  });
+//});
diff --git a/web/regression/javascript/sqleditor/keyboard_shortcuts_spec.js b/web/regression/javascript/sqleditor/keyboard_shortcuts_spec.js
index d7e18567..1ad9c0ad 100644
--- a/web/regression/javascript/sqleditor/keyboard_shortcuts_spec.js
+++ b/web/regression/javascript/sqleditor/keyboard_shortcuts_spec.js
@@ -7,7 +7,7 @@
 //
 //////////////////////////////////////////////////////////////////////////
 
-import keyboardShortcuts from 'sources/keyboard_shortcuts';
+import * as keyboardShortcuts from 'sources/keyboard_shortcuts';
 import {queryToolActions} from 'sources/sqleditor/query_tool_actions';
 import gettext from 'sources/gettext';
 
diff --git a/web/regression/javascript/tree/pgadmin_tree_state_save_spec.js b/web/regression/javascript/tree/pgadmin_tree_state_save_spec.js
index 113f9cbd..9d6065a5 100644
--- a/web/regression/javascript/tree/pgadmin_tree_state_save_spec.js
+++ b/web/regression/javascript/tree/pgadmin_tree_state_save_spec.js
@@ -12,6 +12,7 @@ import {pgBrowser, browserTreeState} from '../../../pgadmin/static/js/tree/pgadm
 
 describe('#browserTreeState', () => {
   beforeEach(() => {
+
     pgBrowser.Nodes = {
       server_group: {
         _type: 'server_group',
@@ -192,10 +193,9 @@ describe('#browserTreeState', () => {
         expect(browserTreeState.current_state, {1: {'paths': ['server_group/1,server/1,coll_database/1','database/10']}});
       });
     });
-  });
 
 
-  describe('When node is closed, node should get removed from the tree state cache', () => {
+
     describe('When coll_database node is closed, both database and coll_database should be removed', () => {
       let item = {
         _type: 'coll_database',
@@ -212,6 +212,7 @@ describe('#browserTreeState', () => {
       });
 
       it('The tree current state will remove coll_database and database', () => {
+        browserTreeState.update_cache(item);
         browserTreeState.remove_from_cache(item);
         expect(browserTreeState.current_state, {1: {'paths': ['server_group/1,server/1']}});
       });
diff --git a/web/webpack.config.js b/web/webpack.config.js
index d188528c..33227558 100644
--- a/web/webpack.config.js
+++ b/web/webpack.config.js
@@ -18,37 +18,15 @@ const sourceDir = __dirname + '/pgadmin/static';
 const webpackShimConfig = require('./webpack.shim');
 const PRODUCTION = process.env.NODE_ENV === 'production';
 const OptimizeCssAssetsPlugin = require('optimize-css-assets-webpack-plugin');
-const ExtractTextPlugin = require('extract-text-webpack-plugin');
-const extractStyle = new ExtractTextPlugin({
+const UglifyJsPlugin = require('uglifyjs-webpack-plugin');
+const MiniCssExtractPlugin = require('mini-css-extract-plugin');
+const extractStyle = new MiniCssExtractPlugin({
   filename: '[name].css',
   allChunks: true,
 });
 const envType = PRODUCTION ? 'production': 'development';
 const HardSourceWebpackPlugin = require('hard-source-webpack-plugin');
 
-// Extract vendor related libraries(node_modules/lib/lib.js) from bundles
-// specified in `chunks` into vendor.js bundle
-const vendorChunks = new webpack.optimize.CommonsChunkPlugin({
-  name: 'vendor',
-  chunks: ['app.bundle', 'sqleditor', 'codemirror', 'debugger_direct'],
-  filename: 'vendor.js',
-  minChunks: function(module) {
-    return webpackShimConfig.isExternal(module);
-  },
-});
-
-// Extract pgAdmin common libraries(pgadmin/web/module/filename.js) from bundles
-// specified in `chunks` into pgadmin_commons.js bundle.
-// pgLibs holds files that will be moved into this bundle.
-const pgAdminCommonChunks = new webpack.optimize.CommonsChunkPlugin({
-  name: 'pgadmin_commons',
-  chunks: ['app.bundle', 'sqleditor', 'codemirror', 'debugger_direct'],
-  filename: 'pgadmin_commons.js',
-  minChunks: function(module) {
-    return webpackShimConfig.isPgAdminLib(module);
-  },
-});
-
 // Expose libraries in app context so they need not to
 // require('libname') when used in a module
 const providePlugin = new webpack.ProvidePlugin({
@@ -64,17 +42,6 @@ const providePlugin = new webpack.ProvidePlugin({
   'window.moment':'moment',
 });
 
-// Minify and omptimize JS/CSS to reduce bundle size. It is used in production
-const uglifyPlugin = new webpack.optimize.UglifyJsPlugin({
-  output: {comments: false},
-  compress: {
-    warnings: false,
-    unused: true,
-    dead_code: true,
-    drop_console: true,
-  },
-});
-
 // Optimize CSS Assets by removing comments while bundling
 const optimizeAssetsPlugin = new OptimizeCssAssetsPlugin({
   assetNameRegExp: /\.css$/g,
@@ -83,15 +50,6 @@ const optimizeAssetsPlugin = new OptimizeCssAssetsPlugin({
   canPrint: true,
 });
 
-// Helps in minimising the `React' production bundle. Bundle only code
-// requires in production mode. React keeps the code conditional
-// based on 'NODE_ENV' variable. [used only in production]
-const definePlugin = new webpack.DefinePlugin({
-  'process.env': {
-    'NODE_ENV': JSON.stringify('production'),
-  },
-});
-
 // Manages the cache and stores it into 'sources/generated/.cache/<env><hash>/' path
 // where env = dev || prod
 const hardSourceWebpackPlugin = new HardSourceWebpackPlugin({
@@ -164,6 +122,8 @@ for(let i=0; i<webpackShimConfig.css_bundle_include.length; i++) {
 pushModulesCss(path.join(__dirname,'./pgadmin'), pgadminStyles);
 
 module.exports = {
+  mode: envType,
+  devtool: false,
   stats: { children: false },
   // The base directory, an absolute path, for resolving entry points and loaders
   // from configuration.
@@ -206,8 +166,7 @@ module.exports = {
       use: {
         loader: 'babel-loader',
         options: {
-          presets: ['es2015'],
-          plugins: ['transform-object-rest-spread'],
+          presets: [['@babel/preset-env', {'modules': 'commonjs'}]],
         },
       },
     }, {
@@ -215,7 +174,7 @@ module.exports = {
       use: {
         loader: 'babel-loader',
         options: {
-          presets: ['es2015'],
+          presets: [['@babel/preset-env', {'modules': 'commonjs'}]],
         },
       },
     }, {
@@ -362,28 +321,25 @@ module.exports = {
       exclude: /vendor/,
     }, {
       test: /\.scss$/,
-      use: extractStyle.extract({
-        use: [{
-          loader: 'css-loader',
-        }, {
-          loader: 'sass-loader', // compiles Sass to CSS
-        }, {
-          /* This will @import with below resources to all scss files */
+      use: [
+        {loader: MiniCssExtractPlugin.loader},
+        {loader: 'css-loader'},
+        {loader: 'sass-loader'},
+        {
           loader: 'sass-resources-loader',
           options: {
             resources: [
               './pgadmin/static/scss/resources/pgadmin.resources.scss',
             ],
           },
-        }],
-      }),
+        },
+      ],
     }, {
       test: /\.css$/,
-      use: extractStyle.extract({
-        use: [{
-          loader: 'css-loader',
-        }],
-      }),
+      use: [
+        MiniCssExtractPlugin.loader,
+        'css-loader',
+      ],
     }],
     // Prevent module from parsing through webpack, helps in reducing build time
     noParse: [/moment.js/],
@@ -403,23 +359,55 @@ module.exports = {
     poll: 1000,
     ignored: /node_modules/,
   },
+  // Webpack 4: uglifyPlugin moved from plugins to optimization
+  optimization: {
+    minimizer: [
+      new UglifyJsPlugin({
+        parallel: true,
+        cache: true,
+        uglifyOptions: {
+          compress: false,
+        },
+      }),
+    ],
+    splitChunks: {
+      cacheGroups: {
+        vendors: {
+          name: 'vendors',
+          filename: 'vendor.js',
+          chunks: 'all',
+          reuseExistingChunk: true,
+          priority: 1,
+          minChunks: 2,
+          enforce: true,
+          test(module) {
+            return webpackShimConfig.isExternal(module);
+          },
+        },
+        secondary: {
+          name: 'pgadmin_commons',
+          filename: 'pgadmin_commons.js',
+          chunks: 'all',
+          priority: 2,
+          minChunks: 2,
+          enforce: true,
+          test(module) {
+            return webpackShimConfig.isPgAdminLib(module);
+          },
+        },
+      },
+    },
+  },
   // Define list of Plugins used in Production or development mode
   // Ref:https://webpack.js.org/concepts/plugins/#components/sidebar/sidebar.jsx
   plugins: PRODUCTION ? [
     extractStyle,
-    vendorChunks,
-    pgAdminCommonChunks,
     providePlugin,
-    uglifyPlugin,
     optimizeAssetsPlugin,
-    definePlugin,
     sourceMapDevToolPlugin,
   ]: [
     extractStyle,
-    vendorChunks,
-    pgAdminCommonChunks,
     providePlugin,
-    definePlugin,
     hardSourceWebpackPlugin,
     sourceMapDevToolPlugin,
   ],
diff --git a/web/webpack.shim.js b/web/webpack.shim.js
index 1f0d9325..cf77af5c 100644
--- a/web/webpack.shim.js
+++ b/web/webpack.shim.js
@@ -138,7 +138,7 @@ var webpackShimConfig = {
     'translations': path.join(__dirname, './pgadmin/tools/templates/js/translations'),
     'sources/gettext': path.join(__dirname, './pgadmin/static/js/gettext'),
     'sources/utils': path.join(__dirname, './pgadmin/static/js/utils'),
-    'babel-polyfill': path.join(__dirname, './node_modules/babel-polyfill/dist/polyfill'),
+    'babel-polyfill': path.join(__dirname, './node_modules/@babel/polyfill/dist/polyfill'),
     'tools': path.join(__dirname, './pgadmin/tools/'),
     'pgbrowser': path.join(__dirname, './pgadmin/browser/static/js/'),
 
diff --git a/web/webpack.test.config.js b/web/webpack.test.config.js
index 0f46348a..7325be3a 100644
--- a/web/webpack.test.config.js
+++ b/web/webpack.test.config.js
@@ -36,8 +36,7 @@ module.exports = {
         use: {
           loader: 'babel-loader',
           options: {
-            presets: ['es2015'],
-            plugins: ['transform-object-rest-spread'],
+            presets: [['@babel/preset-env', {'modules': 'commonjs'}]],
           },
         },
       }, {
